

pub trait DataSource<T> {
    fn get_ith<'a>(&'a self, i: usize) -> Option<&'a T>;
}


pub struct ArraySource<T> {
    words: Vec<T>
}

impl<T> DataSource<T> for ArraySource<T> {
    fn get_ith<'a>(&'a self, i: usize) -> Option<&'a T> {
        self.words.get(i)
    }
}

impl<T> ArraySource<T> {
    pub fn create(words: Vec<T>) -> Self {
        ArraySource {
            words
        }
    }
}
